/* ---------------------------------------------------

    groya.js - ʕϐE֐

    Copyright (c) 2004-2006, 2008, 2009 AOK.

   --------------------------------------------------- */
var regMov = /.+\.(?:mpg|mpeg|wmv|rmvb|rm|ram|asf|asx|avi|mov|qt)$/i;
var regURL = /[\w\-]+\.[\w\-\.\:]+\/[\x21\x23-\x29\x2b-\x5b\x5d-\x7e]+[\w\/]/g;
var reg2ch = /ime\.st\/|ime\.nu\/|pinktower\.com\/\?*|http:\/\/nun\.nu\/\?/g;
var regBrk = /^\s*(?:file:\/\/|mailto:|menu:|about:)/i;
var regImg = /.+\.(?:gif|jpg|png|jpeg|bmp)$/i;

var ie7 = (function() {
  var s = navigator.appVersion.split('MSIE');
  return (parseFloat(s[1]) >= 7);
})();

function z2h(src) {
  var str = '';
  var len = src.length;
  for (var i = 0; i < len; i++) {
    var c = src.charCodeAt(i);
    if (c >= 65281 && c <= 65374 && c != 65340) {
      str += String.fromCharCode(c - 65248);
    } else {
      str += src.charAt(i);
    } 
  }
  return str;
}

function formatNum(keta, num) {
  var src = '' + num;
  var cnt = keta - src.length;
  if (cnt <= 0) return src;
  var str = '';
  while (cnt-- > 0) str += "0";
  return (str + src);
}

/* AԌ`ŏꂽWJ */
function expandStr(str) {
  var list = new Array();
  var reg = /(.*?)\[(\d+)-(\d+)\](.*)/;
  if (str.match(reg) != null) { /* A */
    var keta = RegExp.$2.length;
    var r1 = RegExp.$1;
    var r2 = Number(RegExp.$2);
    var r3 = Number(RegExp.$3);
    var r4 = RegExp.$4;
    for (var i = r2; i <= r3; i++) {
      /* ċAĂяo */
      list = list.concat(expandStr(r1 + formatNum(keta, i) + r4));
    }
  } else { /* AԂłȂ */
    list[0] = str;
  }
  return list;
}

/* zT[`p */
function lsearch(sobj, list) {
  for (var it = 0; it < list.length; it++)
    if (list[it] == sobj) return true;
  return false;
}

/* 񂩂 regexp Ƀ}b` URL z */
function listFromStr(str, regexp) {
  var num = 0;
  var list = new Array();
  var a = str.split("\n");
  for (var i = 0; i < a.length; i++) {
    a[i] = z2h(a[i]);
    var b = a[i].match(regURL);
    if (b == null) continue;
    for (var j = 0; j < b.length; j++) {
      var s = b[j];
      if (!regexp.test(s) || regBrk.test(s)) continue;
      var f = s.search(/\/\//);
      if (f > -1) t = s.substr(f+2); else t = s;
      s = 'http://' + t;
      var c = expandStr(s.replace(reg2ch, ''));
      for (var k = 0; k < c.length; k++) {
        if (!lsearch(c[k], list)) list[num++] = c[k];
        if (num >= 800) return list;
      }
    }
  }
  return list;
}

/* Nz񂩂 regexp Ƀ}b` URL z */
function listFromLinks(links, regexp) {
  var num = 0;
  var list = new Array();
  for (var i = 0; i < links.length; i++) {
    var strURL = links(i).href.replace(reg2ch, '');
    if (regexp.test(strURL) && !regBrk.test(strURL)) {
      var arr = expandStr(strURL);
      for (var j = 0; j < arr.length; j++) {
        if (!lsearch(arr[j], list)) 
          list[num++] = arr[j];
        if (num >= 1000) return list;
      }
    }
  }
  return list;
}

/* 񂩂ŏ URL 擾 */
function getFirstURL(str) {
  if (str != '') {
    var lines = str.split("\n");
    for (var i = 0; i < lines.length; i++) {
      lines[i] = z2h(lines[i]);
      var x = lines[i].match(regURL);
      if (x != null) {
        str = x[0];
        break;
      }
    }
    if (!/^http:\/\/.+/.test(str)) {
      str = 'http://' + str;
    }
  }
  return str.replace(reg2ch, '');
}

/* N擾 */
function getLinkURL(obj) {
  var sURL = '';
  if (obj.tagName == 'A') {
    sURL = obj.href;
  } else if (obj.tagName == 'IMG') {
    if (obj.parentElement.tagName == 'A') {
      sURL = obj.parentElement.href;
      if (/javascript:void\(0\)/i.test(sURL))
        sURL = obj.title;
    } else {
      sURL = obj.src;
    }
  }
  return sURL.replace(reg2ch, '');
}
